
function generate_circle(mode,r, w, n, r1, r2)
	local cp = {}
	if r1 == nil then r1 = 0 end
	if r2 == nil then r2 = 2*math.pi end
	local t = r2/n
	if mode == "inner" then
		r = r-w/2
	elseif mode == "outer" then
		r= r+w/2
	end
	w = w/math.sin(math.pi*(n-2)/(2*n))
	for i=0,n,1 do
		cp[4*i + 1] = (r-w/2)*math.cos(r1+i*t)
		cp[4*i + 2] = (r-w/2)*math.sin(r1+i*t)
		cp[4*i + 3] = (r+w/2)*math.cos(r1+i*t)
		cp[4*i + 4] = (r+w/2)*math.sin(r1+i*t)
	end
	return cp
end


function draw_quadstrip(mode, q, x, y)
	love.graphics.translate( x, y )
	for i=1,#q-4,4 do
		love.graphics.quad( mode,
			q[i], q[i+1], q[i+2], q[i+3],
			q[i+6], q[i+7], q[i+4], q[i+5] )
	end
	love.graphics.translate( -x, -y )
end

--[[
function draw_quadstrip2(mode, q,r1, r2)
	r1 = math.floor(#q*r1)+1
	r2 = 4*math.ceil(r2*#q/4)
	for i=r1,r2-4,4 do
		love.graphics.quad( mode, q[i], q[i+1], q[i+2], q[i+3],
			q[i+6], q[i+7], q[i+4], q[i+5] )
	end
end


function draw_tristrip(mode, q)
	for i=1,#q-4,2 do
		love.graphics.triangle( mode, q[i], q[i+1], q[i+2], q[i+3],
			q[i+4], q[i+5] )
	end
end

function generate_cubic_bezier(bezier, p0,p1,p2,p3,n)
	local t, w
	local len = #bezier
	local nx,ny, tl, x,y
	w = love.graphics.getLineWidth( )/2
	for i=0,n,1 do
		t = i/n
		ny = 3*(1-t)^2*p0[1] + (3-12*t+9*t^2)*p1[1] + (6*t - 9*t^2)*p2[1] + 3*t^2*p3[1]
		nx = 3*(1-t)^2*p0[2] + (3-12*t+9*t^2)*p1[2] + (6*t - 9*t^2)*p2[2] + 3*t^2*p3[2]
		tl = math.sqrt(nx*nx+ny*ny)
		if tl ~= 0 then
				nx = -nx/tl
				ny = ny/tl
		end
		x=(1-t)^3*p0[1] + 3*(1-t)^2*t*p1[1] + 3*(1-t)*t^2*p2[1]+ t^3*p3[1]
		y=(1-t)^3*p0[2] + 3*(1-t)^2*t*p1[2] + 3*(1-t)*t^2*p2[2]+ t^3*p3[2]
		bezier[4*i+1+len] = x - 10*nx
		bezier[4*i+2+len] = y - 10*ny
		bezier[4*i+3+len] = x + 10*nx
		bezier[4*i+4+len] = y + 10*ny
	end

end
]]

function generate_bezier(bezier, p0,p1,p2,n)
	local t, w
	local len = #bezier
	local nx,ny, tl, x, y
	w = love.graphics.getLineWidth( )/2
	for i=0,n,1 do
		t = i/n
		ny = -2*(1-t)*p0[1] + (2-4*t)*p1[1] + 2*t*p2[1]
		nx = -2*(1-t)*p0[2] + (2-4*t)*p1[2] + 2*t*p2[2]
		tl = math.sqrt(nx*nx+ny*ny)
			if tl ~= 0 then
				nx = -nx/tl
				ny = ny/tl
			end
		x = (1-t)*(1-t)*p0[1] + 2*(1-t)*t*p1[1] + t*t*p2[1]
		y = (1-t)*(1-t)*p0[2] + 2*(1-t)*t*p1[2] + t*t*p2[2]
		bezier[4*i+1+len] = x - w*nx
		bezier[4*i+2+len] = y - w*ny
		bezier[4*i+3+len] = x + w*nx
		bezier[4*i+4+len] = y + w*ny
	end

end